# -*- coding: utf-8 -*-
from qgis.core import QgsProject


class LoadedLayers:
    """Acces to the layers that are already open in the project"""

    def __init__(self, parent=None):
        self.project = QgsProject.instance()
        self.layers = dict()

        # FIXME: faire charger les couches par le plugin plutôt que
        # de dépendre du chargement des couches par le projet ?

    def get(self, schema, table):
        if (schema, table) in self.layers:
            return self.layers[(schema, table)]
        for l in self.project.mapLayers().values():
            if '"{}"."{}"'.format(schema, table) in l.source():
                self.layers[(schema, table)] = l
                return l
        return None

    def get_feature(self, schema, table, feature_id, id_key='id'):
        layer = self.get(schema, table)

        if layer:
            for f in layer.getFeatures():
                if f[id_key] == feature_id:
                    return f

    def get_features_by_cond(self, schema, table, select):
        # select(f) a function that return True if the feature f has to be selected
        layer = self.get(schema, table)
        features = []

        if layer is not None:
            for f in layer.getFeatures():
                if select(f):
                    features.append(f)
        return features
