from .paggf_core import PAGGFCore
from . import paggf_version
from .ui.welcome import WelcomeEFDlg


class PAGGF_EF(PAGGFCore):
    TITLE_PARAM = 'Paramétrage et maintenance BD ID'

    def __init__(self, iface):
        super(PAGGF_EF, self).__init__(
            iface, paggf_version.EF, 'EF et Enregistrement TD')
        self.welcome_dlg_class = WelcomeEFDlg

    def toolbar_list_def(self):
        return []

    def paggf_menu_content(self):
        return [  # DEFINITION DE L'ARBRE DU MENU
            # quand (nom, list) = sous menu
            # quand (nom, nom_action) = un access a une action
            'Saisie Enquête foncière',
            'Saisie croquis orienté EF',
            'Saisie et impression d’un TF',
            (self.TITLE_PARAM, [
                'Paramétrage  BD EF',
                'Synchronisation avec BD centrale'
            ])
        ]

    def default_active_layer(self):
        return self.layers.get("gis", "parcels_to_valid")
