@echo off
:: create the db cluster
::

:: 0. checks if the service exists
sc query paggf_db | find "STATE" >nul
if errorlevel 1 goto :noservice
:: 1. make sure the service is stopped
"%OSGEO4W_ROOT%\bin\nircmd" elevate net stop paggf_db
:waitforstop
echo Waiting for service to stop ...
timeout /t 1 /nobreak >nul
sc query paggf_db | find "STATE" | find "STOPPED" >nul
if errorlevel 1 goto :waitforstop
:: 2. unregister the service if present
"%OSGEO4W_ROOT%\bin\nircmd" elevate "%OSGEO4W_ROOT%\bin\pg_ctl" unregister -N paggf_db
:noservice

:: 3. delete the data directory
rmdir /s /q "%OSGEO4W_ROOT%\apps\paggf\.paggf_db"
:: 4. init the cluster
"%OSGEO4W_ROOT%\bin\pg_ctl" init -D "%OSGEO4W_ROOT%\apps\paggf\.paggf_db"
:: 5. modify port
echo port=55432 >> "%OSGEO4W_ROOT%\apps\paggf\.paggf_db\postgresql.conf"
:: 5. register the new service
"%OSGEO4W_ROOT%\bin\nircmd" elevate "%OSGEO4W_ROOT%\bin\pg_ctl" register -N paggf_db -D "%OSGEO4W_ROOT%\apps\paggf\.paggf_db" -S auto -w
:: 6. start the service
"%OSGEO4W_ROOT%\bin\nircmd" elevate net start paggf_db
:waitforstart
echo Waiting for service to start ...
timeout /t 1 /nobreak >nul
sc query paggf_db | find "STATE" | find "RUNNING" >nul
if errorlevel 1 goto :waitforstart

:: create the db
"%OSGEO4W_ROOT%\bin\createdb" -p 55432 paggf
:: create extension and grant user
echo create extension paggf cascade | "%OSGEO4W_ROOT%\bin\psql" -p 55432 paggf
echo drop user if exists paggf_op | "%OSGEO4W_ROOT%\bin\psql" -p 55432 paggf
echo create user paggf_op | "%OSGEO4W_ROOT%\bin\psql" -p 55432 paggf
echo grant paggf_operator to paggf_op | "%OSGEO4W_ROOT%\bin\psql" -p 55432 paggf

textreplace -std -t "%OSGEO4W_ROOT%\apps\paggf\paggf_launch.bat"

:: make sure there is no qgis running
nircmd killprocess qgis-dev-bin-g7.2.1.exe

:: overwrite QGIS3.ini
mkdir "%APPDATA%\QGIS\QGIS3\profiles\paggf\QGIS"
copy /Y "%OSGEO4W_ROOT%\apps\paggf\QGIS3.ini" "%APPDATA%\QGIS\QGIS3\profiles\paggf\QGIS"
mkdir "%APPDATA%\postgresql"
copy /Y "%OSGEO4W_ROOT%\apps\paggf\pg_service.conf" "%APPDATA%\postgresql\.pg_service.conf"

:: install shortcuts on desktop
nircmd shortcut "%OSGEO4W_ROOT%\apps\paggf\paggf_launch.bat" "~$folder.desktop$" "SIF-TD Inventaire" "%OSGEO4W_ROOT%\apps\paggf\paggf_encodage_cid.qgs" "%OSGEO4W_ROOT%\apps\paggf\icon.ico"
nircmd shortcut "%OSGEO4W_ROOT%\apps\paggf\paggf_launch.bat" "~$folder.desktop$" "SIF-TD Immatriculation" "%OSGEO4W_ROOT%\apps\paggf\paggf_encodage_bm.qgs" "%OSGEO4W_ROOT%\apps\paggf\icon.ico"
nircmd shortcut "%OSGEO4W_ROOT%\apps\paggf\paggf_launch.bat" "~$folder.desktop$" "SIF-TD Enregistrement" "%OSGEO4W_ROOT%\apps\paggf\paggf_encodage_ef.qgs" "%OSGEO4W_ROOT%\apps\paggf\icon.ico"
